export class PropertyReplacementHandle {
    _object;
    _key;
    _oldValue;
    constructor(object, key, getValue) {
        this._object = object;
        this._key = key;
        const oldValue = this._oldValue = object[key];
        const newValue = getValue(oldValue);
        object[key] = newValue;
    }
    restore() {
        this._object[this._key] = this._oldValue;
    }
}
export function replacePropertyWith(object, key, getValue) {
    return new PropertyReplacementHandle(object, key, getValue);
}
export default replacePropertyWith;
